#include "COSSCache.h"
#include "CacheManager.h"
#include "pCache.h"
#include <iostream>

// COSSCache does not really implement any policy. The COSS file-system call abort(...)
// to free any segments that are about to be overwritten by the cyclic file-system.


//	Calling the parent default constructor
COSSCache::COSSCache() : Cache()
{
}

void COSSCache::removeItem(PageCluster *_pc)
{
    //stats->lprintf(Stats::INFO, "Cache: detaching item: %s", (*_itr)->objId.c_str()); 
}

void COSSCache::abortPC(PageCluster* _pc)
{
    Item *_item = _pc->item;
    //	in addition the PageCluster should be removed from the CacheManager's Hash Table
    cacheManager->remove(_pc->objId, _pc);
    if (_item->pcList.empty()) {
        delete _item;
    }
}

//	insert an item into the queue, for LRU policy
//	we don't need to use the servedSize field
void COSSCache::insertItem(PageCluster *_pc, long long servedSize, long long pcServedSize)
{
    // stats->lprintf(Stats::INFO, "Cache: pushing back item: %s", _pc->objId.c_str()); 
}

//	Remove a PageCluster from the candidate Item in the queue
void COSSCache::_free()
{
    // Not implemented, this should never be called.
    // We achieve this by setting a very high high-watermark!
    // assert(0); 
}

// free_init() and friend functions should not get the lock, actually, the callers should have
// already got the lock, otherwise we are facing serious race conditions.
void COSSCache::free_init()
{
    // Not implemented, this should never be called.
    assert(0);
}

PageCluster* COSSCache::getFreeCandidate()
{
    // Not implemented, this should never be called.
    assert(0);
	return NULL;
}

void COSSCache::freeCurrent()
{
    // Not implemented, this should never be called.
    assert(0);
}

