#ifndef __COSSCACHE_H
#define __COSSCACHE_H

// COSS replacement policy implements a dummy policy as the one used in
// Squid's COSS file system. The replacement decision is made by the
// FIFO queue.
// To use COSS policy, one should choose COSS access method in conf.txt file.
// Doing so, the command-line replacement policy choice will be overridden.
// Last, the high/low watermarks make no sense in COSS, and are not used.

#include "Cache.h"
#include "Segment.h"
#include "Item.h"

class COSSCache : public Cache
{
public:	
	COSSCache();								//	default constructor
	void free_init();						//	initialize the candidate iterators
	PageCluster* getFreeCandidate();		//	find a candidate PageCluster to be removed
	void freeCurrent();						//	remove the current PageCluster which candidate
											//	iterators point to, from the cache
	void removeItem(PageCluster *_pc);
	void insertItem(PageCluster *_pc, long long serverSize, long long pcServedSize);
	void abortPC(PageCluster* _pc);
	void _free();
    inline bool item_based() {return true; };
    inline int policy() { return COSS; };
private:
};

#endif	//	__COSSCACHE_H
