#ifndef __GNUTELLAIDENTIFIER_H
#define __GNUTELLAIDENTIFIER_H

#include "Conn.h"
#include "TrafficIdentifier.h"
#include "Util.h"

//class Conn;

class GnutellaIdentifier : public TrafficIdentifier {
private:
    Conn* conn;
    long long s2c_remain_data;    // remaining data message size
    char str_buf[Conn::BUFSIZE];  // internal buffer for string search

public:

    // we check the very first few bytes to see whether its a "GIV " or 
    // "GET /uri-res/" prefix. We simply the comparison by assuming
    // the these 4 or 13 bytes are received in one shot and aligned
    // to the head of the buffer
	static bool identify(char* buf, int buf_len) {
        /*  if the input string does contain "GET /uri-res/" string   */
        if (memcmp(buf, "GET /uri-res/", 13) == 0 || 
            memcmp(buf, "GIV ", 4) == 0) {
		    //std::cout << "A Gnutella request" << std::endl;
            return true;
        } 
        else {
		    //std::cout << "Not a Gnutella request" << std::endl;
            return false;
        }
    }

    GnutellaIdentifier(char* buf, int buf_len, Conn* conn);
    ~GnutellaIdentifier();
    int c2sFilter(char** _start, char* _begin, char** _end);
    int s2cFilter(char** _start, char* _begin, char** _end, char** start_offset);
    bool createRequest(char *buf, int* buf_len, Segment* seg); 
    bool createResponse(char *buf, int* buf_len, Segment* seg);
};

#endif
