#include "pCache.h"
#include "Cache.h"
#include "Page.h"
#include "Util.h"
#include "Item.h"

// the constructor takes total size (including header fields)
// actual data length will be computed
Page::Page(long long _ttl_size) : 
    pc(NULL)
{
	size = _ttl_size;
#ifdef	NO_DATA
    data = new char[1];
#else
	data = new char[size];
#endif
}

Page::~Page() {
    if (data != NULL) delete[] data;
    data = NULL;
    assert(pc == NULL);
}

std::string Page::toString() {
    std::string ret("");
    ret.append("Size: ").append(Util::stringify(size));
#ifdef SUPER_VERBOSE
    ret.append(" PageCluster: ");
    if (pc == NULL) ret.append(" null");
    else {
        ret.append(" ObjId: ").append(pc->objId);
        ret.append(" Offset: ").append(Util::stringify(pc->offset));
        ret.append(" Length: ").append(Util::stringify(pc->length));
        ret.append(" RefCnt: ").append(Util::stringify(pc->refCnt));
        ret.append(" State: ").append(Util::stringify(pc->state));
    }
#endif // SUPER_VERBOSE
    return ret;
}

// we only define less operator for sorted set
// we use left_offset to sort them
bool Page::operator< (const Page &other) const{
    if (mCache->policy() != Cache::P2P) {
        return weight < other.weight;
    }
    // P2P
    if (this->pc->item == NULL || 
        other.pc->item == NULL ||
        this->pc->item->freq == other.pc->item->freq) {
        return this->pc->gamma < other.pc->gamma;
    } 
    return this->pc->item->freq < other.pc->item->freq;
}


