#ifndef __PAGE_H
#define __PAGE_H

#include <list>
#include <string>
#include "PageCluster.h"

// a page of pre-allocated memory
//
// Note: The length (data portion) of each page is not explicitly specified. It is implicitly specified
//       by the pages table in page cluster. The pages table uses offset as the key, and pointer to a
//       page as the value. See page cluster class for more detail.
class Page {
    private:

    public:
        PageCluster *pc;        // Pointer toward current assigned page cluster
                                // This pointer should be updated in PagePool.allocate() function...
        long long size;              // Capacity of allocated space (not the valid data length), 
                                // data length for each page cluster is stored in its header
        char *data;             // Buffer array
        Page(long long _ttl_size);   // Allocate data buffer here
        ~Page();                // Free data buffer here
        std::string toString(); // For debugging
        double weight;          // Weight used for replacement policy other than P2P:
                                // it's the timestamp;
                                
        // we define less operator for sorted set
        bool operator< (const Page &other) const;
};

#endif // __PAGE_H
