#include "Segment.h"
#include "Util.h"

Segment::Segment()
{
	objId		=	"1234567890123456789012";
    lRange		=	0;
	rRange		=	0;
	timestamp	=	0;
	piecelen	=	0;
}

Segment::Segment(const std::string &_objId, long long _lRange, long long _rRange):
	objId(_objId), lRange(_lRange), rRange(_rRange), piecelen(MAX_INT_VALUE)
{
}

Segment::Segment(const std::string &_objId, long long _lRange, long long _rRange, long long _timestamp):
	objId(_objId), lRange(_lRange), rRange(_rRange), timestamp(_timestamp), piecelen(MAX_INT_VALUE)
{
}

Segment::Segment(const std::string &_objId, long long _lRange, long long _rRange, long long _timestamp, int _piecelen):
	objId(_objId), lRange(_lRange), rRange(_rRange), timestamp(_timestamp), piecelen(_piecelen)
{
}

Segment::~Segment()
{
}

std::string Segment::toString() {
    std::string ret("");
    ret.append("objId: ").append(objId);
    ret.append(" lRange: ").append(Util::stringify(lRange));
    ret.append(" rRange: ").append(Util::stringify(rRange));
    ret.append(" timestamp: ").append(Util::stringify(timestamp));
    return ret;
}
