#ifndef __SEGMENT_H
#define __SEGMENT_H

#include <string>

class Segment
{
public:
	Segment();
	Segment(const std::string &, long long, long long);
	Segment(const std::string &, long long, long long, long long);
	Segment(const std::string &, long long, long long, long long, int);
	~Segment();
    std::string toString();

	std::string	objId;					//	32 char
	long long	lRange;					//	The first byte (inclusive)
	long long	rRange;					//	The last byte (exclusive)
	long long	timestamp;				//	request timestamp
	int piecelen;

	bool operator<(const Segment& rhs) const
	{
		return (this->timestamp < rhs.timestamp);
	}

	bool operator>(const Segment& rhs) const
	{
		return (this->timestamp > rhs.timestamp);
	}
};

#endif	//	ifndef __SEGMENT_H
